
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>聊聊Zookeeper-快速开始 / iVAN</title>

    <meta name="description" content="聊聊Zookeeper-快速开始 什么是Zookeeper Zookeeper是一个高性能的分布式应用协调服务的框架.Zookeeper=Zoo+keeper,中文直译是动物园的看守者. 为什么要使用Zookeeper Zookeeper可以用于解决很多分布式系统遇到的问题,比如分布式锁,分布式协调,分布式消息队列等. 安装Zookeeper 在官网下载最新的Zookeeper稳定版,http://zookeeper.apache.org/releases.html#download,将下载的文件存放在本地目录及安装完毕,本文将">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">聊聊Zookeeper-快速开始</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<h1>什么是Zookeeper</h1>
<p>Zookeeper是一个高性能的分布式应用协调服务的框架。Zookeeper=Zoo+keeper,中文直译是动物园的看守者。</p>
<h1>为什么要使用Zookeeper</h1>
<p>Zookeeper可以用于解决很多分布式系统遇到的问题，比如分布式锁，分布式协调，分布式消息队列等。</p>
<h1>安装Zookeeper</h1>
<p>在官网下载最新的Zookeeper稳定版，<a>http://zookeeper.apache.org/releases.html#download</a>,将下载的文件存放在本地目录及安装完毕，本文将Zookeeper安装在/Developer/java/project目录。本文下载的是zookeeper-3.4.9版本。</p>
<h1>单机模式启动Zookeeper</h1>
<p>下载完之后，将conf目录下的zoo_sample.cfg文件重命名成zoo.cfg文件。这个文件存放着Zookeeper的所有配置信息。</p>
<pre><code>tickTime=2000
initLimit=10
syncLimit=5
dataDir=/tmp/zookeeper
clientPort=2181
maxClientCnxns=60
autopurge.snapRetainCount=3
autopurge.purgeInterval=1
</code></pre>
<ul>
<li>tickTime：客户端和服务器端维持心跳的时间，单位为毫秒。</li>
<li>initLimit：</li>
<li>syncLimit：</li>
<li>dataDir：用来存放快照数据，官方建议不要使用/tmp目录，可以使用/tmp/zookeeper。</li>
<li>clientPort；启动Zookeeper服务的默认端口。</li>
<li>maxClientCnxns：最大客户端连接数。如果客户端的数量超过了指定的数量，则新连接的客户端会抛出java.io.IOException: Connection reset by peer异常。</li>
<li>autopurge.snapRetainCount：</li>
<li>autopurge.purgeInterval：</li>
</ul>
<p>通过zkServer.sh start命令启动Zookeeper，启动后默认端口是2181，启动成功后命令行会回显已经启动成功的标示STARTED。</p>
<pre><code>tengfeifangtf:bin tengfei.fangtf$ sh /Developer/java/project/zookeeper-3.4.9/bin/zkServer.sh start
ZooKeeper JMX enabled by default
Using config: /Developer/java/project/zookeeper-3.4.9/bin/../conf/zoo.cfg
-n Starting zookeeper ...
STARTED
</code></pre>
<h1>通过命令行调用Zookeeper</h1>
<h3>连接Zookeeper</h3>
<p>通过如下命令连接Zookeeper服务器端。如果服务器端不存在，则会抛出java.net.ConnectException: Connection refused异常</p>
<pre><code>tengfeifangtf:bin tengfei.fangtf$ sh /Developer/java/project/zookeeper-3.4.9/bin/zkCli.sh -server 127.0.0.1:2181
Connecting to 127.0.0.1:2181
2016-09-17 22:02:00,703 [myid:] - INFO  [main:Environment@100] - Client environment:zookeeper.version=3.4.9-1757313, built on 08/23/2016 06:50 GMT
2016-09-17 22:02:00,707 [myid:] - INFO  [main:Environment@100] - Client environment:host.name=192.168.100.224
2016-09-17 22:02:00,707 [myid:] - INFO  [main:Environment@100] - Client environment:java.version=1.6.0_65
2016-09-17 22:02:00,710 [myid:] - INFO  [main:Environment@100] - Client environment:java.vendor=Apple Inc.
2016-09-17 22:02:00,710 [myid:] - INFO  [main:Environment@100] - Client environment:java.home=/Library/Java/JavaVirtualMachines/1.6.0.jdk/Contents/Home
2016-09-17 22:02:00,710 [myid:] - INFO  [main:Environment@100] - Client environment:java.class.path=/Developer/java/project/zookeeper-3.4.9/bin/../build/classes:/Developer/java/project/zookeeper-3.4.9/bin/../build/lib/*.jar:/Developer/java/project/zookeeper-3.4.9/bin/../lib/slf4j-log4j12-1.6.1.jar:/Developer/java/project/zookeeper-3.4.9/bin/../lib/slf4j-api-1.6.1.jar:/Developer/java/project/zookeeper-3.4.9/bin/../lib/netty-3.10.5.Final.jar:/Developer/java/project/zookeeper-3.4.9/bin/../lib/log4j-1.2.16.jar:/Developer/java/project/zookeeper-3.4.9/bin/../lib/jline-0.9.94.jar:/Developer/java/project/zookeeper-3.4.9/bin/../zookeeper-3.4.9.jar:/Developer/java/project/zookeeper-3.4.9/bin/../src/java/lib/*.jar:/Developer/java/project/zookeeper-3.4.9/bin/../conf:
2016-09-17 22:02:00,711 [myid:] - INFO  [main:Environment@100] - Client environment:java.library.path=.:/Library/Java/Extensions:/System/Library/Java/Extensions:/usr/lib/java
2016-09-17 22:02:00,711 [myid:] - INFO  [main:Environment@100] - Client environment:java.io.tmpdir=/var/folders/6s/z6xt4ypn387239k7q1ty_rkc0000gn/T/
2016-09-17 22:02:00,713 [myid:] - INFO  [main:Environment@100] - Client environment:java.compiler=&lt;NA&gt;
2016-09-17 22:02:00,713 [myid:] - INFO  [main:Environment@100] - Client environment:os.name=Mac OS X
2016-09-17 22:02:00,714 [myid:] - INFO  [main:Environment@100] - Client environment:os.arch=x86_64
2016-09-17 22:02:00,714 [myid:] - INFO  [main:Environment@100] - Client environment:os.version=10.11.6
2016-09-17 22:02:00,714 [myid:] - INFO  [main:Environment@100] - Client environment:user.name=tengfei.fangtf
2016-09-17 22:02:00,714 [myid:] - INFO  [main:Environment@100] - Client environment:user.home=/Users/tengfei
2016-09-17 22:02:00,714 [myid:] - INFO  [main:Environment@100] - Client environment:user.dir=/Developer/java/project/zookeeper-3.4.9/bin
2016-09-17 22:02:00,716 [myid:] - INFO  [main:ZooKeeper@438] - Initiating client connection, connectString=127.0.0.1:2181 sessionTimeout=30000 watcher=org.apache.zookeeper.ZooKeeperMain$MyWatcher@3a21b220
Welcome to ZooKeeper!
2016-09-17 22:02:00,754 [myid:] - INFO  [main-SendThread(127.0.0.1:2181):ClientCnxn$SendThread@1032] - Opening socket connection to server 127.0.0.1/127.0.0.1:2181. Will not attempt to authenticate using SASL (java.lang.SecurityException: Unable to locate a login configuration)
JLine support is enabled
2016-09-17 22:02:00,775 [myid:] - INFO  [main-SendThread(127.0.0.1:2181):ClientCnxn$SendThread@876] - Socket connection established to 127.0.0.1/127.0.0.1:2181, initiating session
[zk: 127.0.0.1:2181(CONNECTING) 0] 2016-09-17 22:02:01,075 [myid:] - INFO  [main-SendThread(127.0.0.1:2181):ClientCnxn$SendThread@1299] - Session establishment complete on server 127.0.0.1/127.0.0.1:2181, sessionid = 0x157386e843d0004, negotiated timeout = 30000

WATCHER::

WatchedEvent state:SyncConnected type:None path:null
</code></pre>
<p>连接成功后会进入Zookeeper交互式窗口，命令行左边显示如下，然后你就可以使用Zookeeper提供的命令来创建，修改和删除节点。</p>
<pre><code>[zk: 127.0.0.1:2181(CONNECTED) 0]
</code></pre>
<h3>创建节点</h3>
<p>使用create参数创建节点，第一个参数是节点路径，第二个参数是节点的数据。</p>
<pre><code>[zk: 127.0.0.1:2181(CONNECTED) 1] create /dmcNode data
Created /dmcNode
</code></pre>
<blockquote><p>注意：节点路径是大小写敏感的。</p></blockquote>
<h3>查看节点</h3>
<p>使用get命令查询节点的数据，会显示节点的数据长度，数据的版本</p>
<pre><code>[zk: 127.0.0.1:2181(CONNECTED) 2] get /dmcNode
data
cZxid = 0x54
ctime = Sat Sep 17 22:07:49 CST 2016
mZxid = 0x54
mtime = Sat Sep 17 22:07:49 CST 2016
pZxid = 0x54
cversion = 0
dataVersion = 0
aclVersion = 0
ephemeralOwner = 0x0
dataLength = 4
numChildren = 0
</code></pre>
<p>通过get命令我们可以看到Zookeeper节点的数据结构</p>
<ul>
<li>cxxid：当前节点事务的xxid。</li>
<li>ctime：当前节点的创建时间。</li>
<li>mxxid: 当前节点最近修改的xxid。</li>
<li>pZxid ： 子节点的最后版本</li>
<li>cversion：这个节点的子节点变化次数，创建一个子节点会加1。</li>
<li>dataVersion：数据的版本，每次修改会加一。</li>
<li>aclVersion：这个节点的ACL变化次数。</li>
<li>ephemeralOwner ：如果这个节点是临时节点，表示创建者的会话id。如果不是临时节点，这个值是0。</li>
<li>dataLength：这个节点存放的数据长度。</li>
<li>numChildren：这个节点的子节点个数。</li>
<li>mtime：这个节点的最后修改时间。</li>
</ul>
<p>这些属性可以参考《Zookeeper官方文档》Zookeeper tatStructure章节<a>https://zookeeper.apache.org/doc/r3.4.6/zookeeperProgrammers.html#sc_zkStatStructure</a></p>
<h3>修改节点</h3>
<p>可以发现dataVersion从刚才的0变成了1，数据长度也变化了。</p>
<pre><code>[zk: 127.0.0.1:2181(CONNECTED) 3] set /dmcNode data1
cZxid = 0x54
ctime = Sat Sep 17 22:07:49 CST 2016
mZxid = 0x55
mtime = Sat Sep 17 22:10:46 CST 2016
pZxid = 0x54
cversion = 0
dataVersion = 1
aclVersion = 0
ephemeralOwner = 0x0
dataLength = 5
numChildren = 0
</code></pre>
<h3>删除节点</h3>
<p>通过delete [path]命令删除节点</p>
<pre><code>[zk: 127.0.0.1:2181(CONNECTED) 12] delete /dmcNode
</code></pre>
<h3>help命令</h3>
<p>我们通过help命令可以看下Zookeeper提供哪些操作命令。</p>
<pre><code>[zk: 127.0.0.1:2181(CONNECTED) 0] help
ZooKeeper -server host:port cmd args
    connect host:port
    get path [watch]
    ls path [watch]
    set path data [version]
    rmr path
    delquota [-n|-b] path
    quit
    printwatches on|off
    create [-s] [-e] path data acl
    stat path [watch]
    close
    ls2 path [watch]
    history
    listquota path
    setAcl path acl
    getAcl path
    sync path
    redo cmdno
    addauth scheme auth
    delete path [version]
    setquota -n|-b val path
</code></pre>
<ul>
<li>quit：退出连接。</li>
<li>history：查看当前连接历史执行命令。</li>
</ul>
<h2>关闭Zookeeper</h2>
<p>如果先关闭了Zookeeper服务端，而客户端没有关闭，则客户端会不断的重连服务器端，并抛出异常closing socket connection and attempting reconnect。</p>
<pre><code>sh /Developer/java/project/zookeeper-3.4.9/bin/zkServer.sh stop
</code></pre>
<h1>通过Java API调用Zookeeper</h1>
<h2>1：引入POM</h2>
<pre><code>&lt;dependency&gt;
  &lt;groupId&gt;org.apache.zookeeper&lt;/groupId&gt;
  &lt;artifactId&gt;zookeeper&lt;/artifactId&gt;
  &lt;version&gt;3.4.7&lt;/version&gt;
&lt;/dependency&gt;
</code></pre>
<h2>2：Java测试代码</h2>
<p>演示了ZooKeeper节点的创建，修改和删除操作。</p>
<pre><code>import java.io.IOException;

import org.apache.zookeeper.CreateMode;
import org.apache.zookeeper.KeeperException;
import org.apache.zookeeper.ZooDefs;
import org.apache.zookeeper.ZooKeeper;

/**
 *
 * @author tengfei.fangtf
 * @version $Id: TestZookeeper.java, v 0.1 Sep 14, 2016 5:05:07 PM tengfei.fangtf Exp $
 */
public class TestZookeeper {

    public static void main(String[] args) throws IOException, InterruptedException,
                                           KeeperException {
        //创建ZooKeeper实例
        ZooKeeper zk = new ZooKeeper("127.0.0.1:2181", 100, null);
        String path = "/dmc";

        //创建一个节点,模式是PERSISTENT
        zk.create(path, "1".getBytes(), ZooDefs.Ids.OPEN_ACL_UNSAFE, CreateMode.PERSISTENT);
        System.out.println("创建节点" + path + ",数据为：" + new String(zk.getData(path, null, null)));
        //修改节点数据
        zk.setData(path, "2".getBytes(), -1);
        System.out.println("修改节点" + path + ",数据为：" + new String(zk.getData(path, null, null)));
        //删除一个节点
        System.out.println(zk.exists(path, null));
        zk.delete(path, -1);
        //节点是否存在
        System.out.println(zk.exists(path, null));

    }

}
</code></pre>
<p>输出的结果如下：</p>
<pre><code>创建节点/dmc,数据为：1
修改节点/dmc,数据为：2
78,79,1474120607561,1474120607575,1,0,0,0,1,0,78

null
</code></pre>
<h1>参考资料</h1>
<ul>
<li><a href="http://ifeve.com/apache-zookeeper-3/" rel="external nofollow noreferrer">《Apache Zookeeper 官方文档》-3 快速指南</a></li>
<li><a href="http://www.ibm.com/developerworks/cn/opensource/os-cn-zookeeper/index.html" rel="external nofollow noreferrer">分布式服务框架 Zookeeper — 管理分布式环境中的数据</a></li>
<li>转载自 <a href="http://ifeve.com/" rel="external nofollow noreferrer">并发编程网 - ifeve.com</a></li>
</ul>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-11 07:17:20</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/apache/" title="apache">apache</a>, <a href="https://www.iamivan.net/tag/%e5%88%86%e5%b8%83%e5%bc%8f/" title="分布式">分布式</a>, <a href="https://www.iamivan.net/tag/path/" title="path">path</a>, <a href="https://www.iamivan.net/tag/java/" title="java">java</a>, <a href="https://www.iamivan.net/tag/zookeeper/" title="zookeeper">zookeeper</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>聊聊Zookeeper-快速开始的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mvm5nNb.html" rel="bookmark">ZooKeeper管理员指南&mdash;&mdash;部署与管理ZooKeeper</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文以ZooKeeper3.4.3版本的官方指南为基础:http://zookeeper.apache.org/doc/r3.4.3/zookeeperAdmin.html,补充一些作者运维实践中的要点,围绕ZK的部署和运维两个方面讲一些管理员需要知道的东西.本文并非一个ZK搭建的快速入门,关于这方面,可以查看&lt;ZooKeeper快速搭建&gt;. 1.部署 本章节主要讲述如何部署ZooKeeper,包括以下三部分的内容: 系统环境 集群模式的配置 单机模式的配置 系统环境和集群模式配置这两节内容大			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pPlV0qp.html" rel="bookmark">解析xHTML源码的DLL组件AngleSharp介绍&lowbar;实用技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				AngleSharp是基于.NET(C#)开发的专门为解析xHTML源码的DLL组件. 项目地址:https://github.com/FlorianRappl/AngleSharp 国内:Jumony github地址: https://github.com/Ivony/Jumony 国外:Html Agility Pack 项目地址:http://htmlagilitypack.codeplex.com/ 具体大家可以自行搜索对比三者的区别和性能.接下来咱们主要讨论主角是AngleSharp			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p58VYWM.html" rel="bookmark">调查显示近8成网友赞同火车站票半价售卖</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前几日,新浪http://www.aliyun.com/zixun/aggregation/13171.html&quot;&gt;微博认证信息为&quot;自由撰稿人,社会公益工作者&quot;的网友@卫庄发布了一条名为&quot;呼吁无座火车票应该半价&quot;微博,微博称,&quot;中国铁路每年售出大量无座票,然而长期以来,无座车票依然全价出售.无座旅客以农民工兄弟居多,他们因为知识等原因,抢不到属于自己的有座票.按照市场价值规律,他们没能享受与车票价钱所匹配的服务,因此无座车票全价不合理.&q			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bQwkWOp.html" rel="bookmark">站票半价获网友压倒性支持 相关反对言论遭炮轰</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				中新网1月16日电(生活频道 蒋妍) 12日,认证身份为自由撰稿人.社会公益工作者的网友卫庄发布了一条标题为&quot;呼吁无座火车票应该半价&quot;的微博,短短几天内,该微博已被转发近16万次,评论近4万条.&quot;无座火车票半价&quot;也一时之间成为网友热烈讨论的话题,各路观点层出不穷,但在大多数网友的强烈支持声中,也有相关人士对此持反对态度. 微博呼吁站票半价 微博原文@卫庄:http://www.aliyun.com/zixun/aggregation/33132.html&quot;			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mr3PN4p.html" rel="bookmark">基于资源编排在专有网络环境下快速部署高可用的Dubbox服务（ZooKeeper版）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文将介绍在专有网络VPC(Virtual Private Cloud)下,基于资源编排服务,快速部署高可用的Dubbox服务的过程.Dubbox服务采用的注册中心是ZooKeeper集群.做这件事情的意义在于:节约部署Dubbox的时间,降低部署Dubbox过程中出错的风险. ROS阿里云资源编排(Resource Orchestration)是一种简单易用的云计算资源管理和自动化运维服务.用户通过模板描述多个云计算资源的依赖关系.配置等,并自动完成所有资源的创建和配置,以达到自动化部署.运维			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pPBxkDb.html" rel="bookmark">《Apache Zookeeper 官方文档》-3 快速指南：使用zookeeper来协调分布式应用</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本节内容让你快速入门zookeeper.它主要针对想尝试使用zookeeper的开发者,并包含一个ZooKeeper单机服务器的安装说明,你可以用一些命令来验证它的运行,以及简单的编程实例.最后,为了考虑到方便性,有一些复杂的安装部分,例如运行集群式的部署安装,优化事务日志将不在本文档中说明.对于商业部署的完整说明,请参阅管理员指南. 一:前提准备条件 请看下管理员指南中的  System Requirements . 二:下载 从Apache 镜像里面下载最近的一个稳定版本ZooKeeper 			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MgQDV3z.html" rel="bookmark">简单快速ZooKeeper搭建配置</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.单机模式 1.配置JDK环境,略过. 2.获取及下载zookeeper 下载地址:http://mirror.bit.edu.cn/apache/zookeeper/stable/ ,  代码如下 复制代码 #wget http://mirror.bit.edu.cn/apache/zookeeper/zookeeper-3.4.6/zookeeper-3.4.6.tar.gz #tar zxvf zookeeper-3.4.6.tar.gz -C /usr/local #cd /usr/l			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MxoA8Rb.html" rel="bookmark">DockOne微信分享（一二九）：聊聊Service Mesh：linkerd</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文讲的是DockOne微信分享(一二九):聊聊Service Mesh:linkerd[编者的话]随着企业逐渐将传统的单体应用向微服务或云原生应用的转变,虽然微服务或者云原生应用能给企业带来更多的好处,但也会带来一些具有挑战的问题,如怎么管理从单体应用转向微服务所带来的服务间通讯的复杂性,怎么实现微服务间安全,高效,可靠的访问,如何满足多语言多环境的透明通讯,服务发现.熔断,动态流量迁移,金丝雀部署,跨数据中心访问等等.本次分享给大家引入一新概念服务网格(Service Mesh)以及介绍业界			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/5zOnmqp.html" rel="bookmark">内行看门道！聊聊交互原则那些事儿</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  刚学习交互设计的新人,面对繁多的交互设计原则,肯定晕头转向.总不能每款产品都按着交互原则一一比对吧?今天资深交互设计师老D由浅及深,聊聊交互原则的那些事儿,特别适合新人呦. 为什么需要设计原则? 设计原则其实就是对一些设计过程中基于人类的认知规律对设计做出的一些指导性原则,并且对已经成为行业共识的设计经验做个总结,用来指导设计师界定问题.提高效率. 经常用的设计原则有哪些? 先来抛一个老D在早年刚接触交互设计的时候最为大家所认可的几条设计原则: 1. 可学习性 目标用户在已有的知识和经验基础			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/XpmVBBz.html" rel="bookmark">聊聊2015年流行的网页设计趋势</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  给明年的自己增加筹码!这一年快结束了,年底特别忙,但也别只顾工作,忘了给自己充电呦,今天特意分享一篇好文,聊聊明年将流行的设计趋势,希望能给那些奋战之余不忘充实自己的设计师们一点有价值的参考,每点趋势后都有相关文章帮你理解,不担心跟不上咯. 1. 响应式在继续 OK,也许你不打算打道回府.也许你有一个很好的理由不用响应式网页设计?在过去的几年里,响应设计快速巩固了自己作为网页设计的新标准.当然,也有争论,但是没人说,&quot;让我们摆脱响应式设计吧&quot;.实际上,越来越多的网站选择响应式的方向			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/7M0O06b.html" rel="bookmark" class="title">如何增加网站有效高质量外链 提高外链稳定性</a>
					<div>
						互联网上这类文章,也许大家都看的多了,但是我还是想在这里给大家总结下我个人心理看法,希望大家别拍砖O(∩_∩)O哈! 说到高质量外链,作为站长来说确实非常重要,也是大家青睐的一个名词,那么我们如何增加 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/1MvPOrz.html" rel="bookmark" class="title">通过java&period;net&period;Socket 类抓取网页内容</a>
					<div>
						网页 /** 文件名 : FirstSocket.java 描述 :通过 java.net.Socket 类访问一个Web页面,并且返回结果 作者: 慈勤强 cqq1978@yeah.net 参考:h ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/qzDox6p.html" rel="bookmark" class="title">初探PHP5</a>
					<div>
						php5 虽然 PHP5 还没有正式发布(开发版本已经提供下载),但我们现在就可以开始体验一下新的版本 将要带给我们的惊喜.在以下的介绍中,我们将重点讲述 PHP5 中的三大特色功能.这三大特点为:  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OM9r03p.html" rel="bookmark" class="title">用PHP制作静态网站的模板框架&lpar;四&rpar;</a>
					<div>
						静态网站的模板框架 首先,我们象前面一样为所有的页面公用元素以及页面整体布局编写模板文件:然后从所有的页面删除公共部分,只留下页面内容:接下来再在每个页面中加上三行PHP代码,如下所示: &lt;?p ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/aM1Vwdp.html" rel="bookmark" class="title">搜索引擎对外部链接以权威性判定其重要程度</a>
					<div>
						做为一名网站站长,并且是对其网站关键词进行过seo推广的网站站长来说,都会知道外部链接对seo的重要性.但就做外链而言,它确实存在不小的难度,很多站长至今也没找到合适的方式去完善的处理这一问题.在关键 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OM96WVp.html" rel="bookmark" class="title">如何用VB&period;Net创建一个三层的数据库应用程序&lpar;转贴</a>
					<div>
						程序|创建|数据|数据库 1. 概论: 本文将介绍如何创建一个三层应用程序,并且将介绍如何创建一个Web Service服务. ADO.NET创建Windows三层结构应用程序的体系架构如下图所示:  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5AjdAp.html" rel="bookmark" class="title">Photoshop绘制一盏古典的陶瓷油灯</a>
					<div>
						效果图构造稍微有点复杂,有点类似阶梯构造.制作的时候先设定好光源方向,然后由底层开始慢慢细化高光及暗部,逐层做出各部分即可. 最终效果 &lt;点小图查看大图&gt; 1.photoshop教程新建一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bElkm6z.html" rel="bookmark" class="title">jquery简单的拖动效果实现原理及示例</a>
					<div>
						本文为大家详细介绍下jQuery拖曵的简单实例,具体的实现思路及代码如下,感兴趣的朋友可以参考下哈,希望对大家有所帮助   复制代码 代码如下: &lt;!DOCTYPE html&gt; &lt;h ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5oRyWb.html" rel="bookmark" class="title">分享淘宝购便利交互设计心得</a>
					<div>
						前段时间一直在做淘宝购便利网站的交互,算是本人第一次真正意义上的做前台项目吧(之前一直是做的后台系统的交互),其中有一些设计上的心得和大家分享一下. 淘宝购便利是快消品销售的&quot;生活平台&qu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGJr3ep.html" rel="bookmark" class="title">Chrome安装Windows Media Player插件的方法</a>
					<div>
						  下在Chrome安装Windows Media Player插件的方法. 1.首先下载Windows Media Player插件 插件的名字为Windows Media Player HTML5 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze7PNNM.html" rel="bookmark" class="title">Photoshop使用调整边缘功能打造后期画意</a>
					<div>
						  最终效果 这是一张在甘南用小DC拍摄300万像素的照片,人物表情和瞬间不错,可惜背景比较杂乱,阴天的光线表现力也不够,于是决定通过后期改换背景和光线,达到想要的画意效果. 首先,我们必须把小女孩的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bo78xEb.html" rel="bookmark" class="title">mac版微信怎么加好友</a>
					<div>
						  登陆电脑版微信之后直接点微信主界面右上角的&quot;+&quot;号,选择&quot;添加朋友&quot;选项 在&quot;添加朋友&quot;界面我们可以看到&quot;雷达加朋友&quot ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bad8Bgz.html" rel="bookmark" class="title">笔记本电脑频繁死机原因和解决方法</a>
					<div>
						  笔记本电脑频繁死机怎么办呢?下面为大家分析下笔记本电脑频繁死机原因和解决方法吧,在进行CMOS设置时也会出现死机现象下. 故障原因:一般是主板设计散热不良或者主板Cache有问题引起的. 处理办法 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8kPnxM.html" rel="bookmark" class="title">网络维护 向本地连接管理要效率</a>
					<div>
						[51CTO.com独家特稿]可以这么说,&quot;本地连接&quot;其实是计算机的网络访问出入口,无论是修改上网参数,还是新建上网连接,我们 往往都要从该连接开始.事实上,在平时的网络维护过程中 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvrwPNM.html" rel="bookmark" class="title">中国互联网的十二月大灾变</a>
					<div>
						开发者门户CSDN泄漏600万用户数据,其中包含极为敏感的用户名.密码.垂直游戏网站多玩网泄漏800万用户数据,大部分加密也有小部分明文保存,措手不及的用户们瑟瑟颤抖. 紧接着51CTO.CNZZ.e ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MY50NZM.html" rel="bookmark" class="title">jsp问题-新人求教，WEB-INF下的jsp的读取</a>
					<div>
						问题描述 新人求教,WEB-INF下的jsp的读取 做了一个页面底部模板,起初模板文件直接放在WebRoot下,使用时&lt;%@ include file=&quot;footer.jsp&quot ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxY7ABp.html" rel="bookmark" class="title">esayui的datagrid如何动态设置列数据</a>
					<div>
						问题描述 esayui的datagrid如何动态设置列数据 我的datagrid中创建了YF1.YF2.....YF12这几个列名,现在想使用for循环为这些列设置值,但是使用updateRow的方法 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmKA4Bb.html" rel="bookmark" class="title">谈谈我的新站是如何推广的</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 做人难,做大学生难,做站长难,做个 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3rlGNz.html" rel="bookmark" class="title">devexpress mvc spreadsheet</a>
					<div>
						问题描述 asp.netmvc项目需要添加devexpressspreadsheet控件.请问当产生从剪贴板粘贴数据时,如何刷新绑定数据源? 解决方案					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdy7Kmz.html" rel="bookmark" class="title">用组策略修改WIN2003 administrator 的用户名的方法&lowbar;应用技巧</a>
					<div>
						因为我的客户机是XP的用户名是 administrator  我的win2003服务器要启用共享文件,这样我的win2003服务器要用账户 administrator 密码是空,客户机才可以浏览我的共 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgwVPmM.html" rel="bookmark" class="title">android-昨天整整弄了一天还是没解决这个问题，非常困惑（有关SQLite的问题）</a>
					<div>
						问题描述 昨天整整弄了一天还是没解决这个问题,非常困惑(有关SQLite的问题) 问题说明:我是用SQLite Expert工具建立了一个routelines.db数据库,里面建了android_me ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnR7vrp.html" rel="bookmark" class="title">闭合浮动，元素浮动或绝对定位后失去文档流的友好解决办法</a>
					<div>
						给父盒子添加一个&quot;clearfix&quot;样式.它一般这样子定义 .clearfix{ zoom:1;//由于IE6-7不支持:after,使用 zoom:1触发 hasLayout.  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBggVJM.html" rel="bookmark" class="title">存储linux RAID6中raid信息丢失的解决方案</a>
					<div>
						数据恢复故障描述: 原存储为12块2T硬盘组成的Linux RAID6,文件系统均为EXT3,此存储上划有3个LUN,每个均为6TB大小,某天在RAID失效后,维护人员为了抢救数据,对此失效的存储重进 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEKZ29p.html" rel="bookmark" class="title">C&plus;&plus;程序设计：原理与实践（进阶篇）15&period;2　STL理念</a>
					<div>
						15.2 STL理念 C++标准库为处理数据序列提供了一个专门的框架,称为STL.STL是标准模板库(Standard Template Library)的简称.STL是ISO C++标准库的部分,它 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLgyoAM.html" rel="bookmark" class="title">腾讯遭遇了前所未有的危机</a>
					<div>
						1.中欧国际工商学院与成为资本共同发起成立&quot;中欧成为创业基金&quot; (CEIBS- Chengwei Venture Capital Fund),第一期基金规模达一亿美元, 专注于投资 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEKkgJp.html" rel="bookmark" class="title">宝姿现涨5&period;25&percnt;德银评买入看15&period;52港元</a>
					<div>
						宝姿(00589-HK)现涨5.25%,报14.04港元,成交434.75万股:该股目前跑赢大市,恒指涨2.69%. 德银上调该股评级至买入,同时还把目标价大幅上调63%至15.52港元.该行指年初至 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bodVkVM.html" rel="bookmark" class="title">三家初创公司有好玩的娱乐产品吸引顾客</a>
					<div>
						创立并经营一家公司是一件很难的事情,但是不管你是多么繁忙的大佬也都需要不时放松娱乐一下.这种主张娱乐精神的做法在上周CES消费电子展览上展出的一些科技初创公司就有很好的提现.下面介绍了这几款产品就是主 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOn5Bxp.html" rel="bookmark" class="title">python使用sorted函数对列表进行排序的方法&lowbar;python</a>
					<div>
						本文实例讲述了python使用sorted函数对列表进行排序的方法.分享给大家供大家参考.具体如下: python提供了sorted函数用于对列表进行排序,并且可以按照正序或者倒序进行排列 #创建一个 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze01ljp.html" rel="bookmark" class="title">dot中subgraph显示没有区域边界（边框）</a>
					<div>
						问题描述 dot中subgraph显示没有区域边界(边框) 下面是一段dot语言的代码: digraph G { subgraph main { label=&quot;main&quot;; bb0 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5Q1aWp.html" rel="bookmark" class="title">没听说过超级狗丽</a>
					<div>
						问题描述 谁有下载地址哦!我试试,哈哈哈哈哈哈哈哈哈哈看看有多囧,哈哈哈哈啊哈 解决方案 解决方案二:&lt;超级狗丽&gt;第一关通关视频演示(优酷)和游戏下载地址:http://user.qzon ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.032 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
